import { type CatalogType, type Status, type TaxMode } from '../../../enums/index.js';
import { type IImportMetaNotificationResponse, type IMoneyNotificationResponse, type ISharedProductNotificationResponse, type ITimePeriodNotification, type IUnitPriceOverrideNotificationResponse } from '../shared/index.js';
import { type IPriceQuantityNotification } from './price-quantity-notification.js';
import { type ICustomData } from '../../../types/index.js';
export interface IPriceNotificationResponse {
    id: string;
    product_id: string;
    description: string;
    type?: CatalogType | null;
    name?: string | null;
    billing_cycle?: ITimePeriodNotification | null;
    trial_period?: ITimePeriodNotification | null;
    tax_mode: TaxMode;
    unit_price: IMoneyNotificationResponse;
    unit_price_overrides: IUnitPriceOverrideNotificationResponse[] | null;
    quantity: IPriceQuantityNotification;
    status: Status;
    created_at?: string | null;
    updated_at?: string | null;
    custom_data?: ICustomData | null;
    import_meta?: IImportMetaNotificationResponse | null;
    product?: ISharedProductNotificationResponse | null;
}
