import { type AdjustmentActionType, type AdjustmentAction, type AdjustmentStatus, type CurrencyCode } from '../../enums/index.js';
import { type IAdjustmentItemResponse } from './adjustment-item-response.js';
import { type IPayoutTotalsAdjustmentResponse, type ITotalAdjustmentsResponse } from '../shared/index.js';
export interface IAdjustmentResponse {
    id: string;
    action: AdjustmentAction;
    type: AdjustmentActionType;
    transaction_id: string;
    subscription_id?: string | null;
    customer_id: string;
    reason: string;
    credit_applied_to_balance: boolean;
    currency_code: CurrencyCode;
    status: AdjustmentStatus;
    items: IAdjustmentItemResponse[];
    totals: ITotalAdjustmentsResponse;
    payout_totals?: IPayoutTotalsAdjustmentResponse | null;
    created_at: string;
    updated_at: string;
}
