import { type AvailablePaymentMethod, type CollectionMode, type CurrencyCode, type TransactionOrigin, type TransactionStatus } from '../../enums/index.js';
import { type IBillingDetailsResponse, type ICustomData, type ITransactionCheckout, type ITransactionPaymentAttemptResponse } from '../shared/index.js';
import { type ITransactionsTimePeriodResponse } from './transactions-time-period-response.js';
import { type ITransactionItemResponse } from './transaction-item-response.js';
import { type ITransactionDetailsResponse } from './transaction-details-response.js';
import { type IAddressResponse } from '../address/index.js';
import { type ITransactionAdjustmentResponse } from './transaction-adjustment-response.js';
import { type IAdjustmentTotalsResponse } from './adjustment-totals-response.js';
import { type IBusinessResponse } from '../business/index.js';
import { type ICustomerResponse } from '../customer/index.js';
import { type IDiscountResponse } from '../discount/index.js';
export interface ITransactionResponse {
    id: string;
    status: TransactionStatus;
    customer_id?: string | null;
    address_id?: string | null;
    business_id?: string | null;
    custom_data?: ICustomData | null;
    currency_code: CurrencyCode;
    origin: TransactionOrigin;
    subscription_id?: string | null;
    invoice_id?: string | null;
    invoice_number?: string | null;
    collection_mode: CollectionMode;
    discount_id?: string | null;
    billing_details?: IBillingDetailsResponse | null;
    billing_period?: ITransactionsTimePeriodResponse | null;
    items: ITransactionItemResponse[];
    details?: ITransactionDetailsResponse | null;
    payments: ITransactionPaymentAttemptResponse[];
    checkout?: ITransactionCheckout | null;
    created_at: string;
    updated_at: string;
    billed_at?: string | null;
    revised_at?: string | null;
    address?: IAddressResponse | null;
    adjustments?: ITransactionAdjustmentResponse[] | null;
    adjustments_totals?: IAdjustmentTotalsResponse | null;
    business?: IBusinessResponse | null;
    customer?: ICustomerResponse | null;
    discount?: IDiscountResponse | null;
    available_payment_methods?: AvailablePaymentMethod[] | null;
}
